#include <iostream>
#include <windows.h>
#include "mainappli.hpp"

typedef MyPluginClass* (*API_MakeInstance)(void);
typedef void (*API_ReleaseInstance)(MyPluginClass* instance);

using std::cout;
using std::endl;

int main(void)
{
	HMODULE hmod;
	/* vOC̊֐ւ̃|C^ */
	API_MakeInstance MakeInstance;
	/* vOC̊֐ւ̃|C^ */
	API_ReleaseInstance ReleaseInstance;

	/* vOCƊ֐̃[h */
	hmod  = LoadLibrary("Plugin.dll");
	MakeInstance = (API_MakeInstance)GetProcAddress(hmod, "MakeInstance");
	ReleaseInstance = (API_ReleaseInstance)GetProcAddress(hmod, "ReleaseInstance");
	if (MakeInstance != NULL && ReleaseInstance != NULL) {
		MyPluginClass* mpc; /* vOC̃NXւ̃|C^ */
		mpc = MakeInstance();
		cout << "Version: " << mpc->GetVersion() << endl;
		ReleaseInstance(mpc);
	}
	/* vOC̉ */
	FreeLibrary(hmod);
	return 0;
}
